#include <stdio.h>

/* Definitions of constants should go here */
#define INITIAL_CONSOLE_STOCK      40
#define INITIAL_GAME_STOCK         100

#define CONSOLE_COST    99.99
#define GAME_COST       29.99
#define PACKAGE_COST    114.99
#define GAMEPAK_COST    119.99

#define CONSOLES_PER_PACKAGE    1
#define GAMES_PER_PACKAGE       2

#define GAMES_PER_GAMEPAK       5

int main(void) {
  char dummychar; /* character to pause output display at end of program */

  /* variable declarations go here: */

  /* current stock */
  int console_stock = INITIAL_CONSOLE_STOCK;
  int game_stock    = INITIAL_GAME_STOCK;

  /* the number of items of each type requested by the order */
  int console_demand;
  int game_demand;
  int package_demand;
  int gamepak_demand;
  
  /* individual item cost totals for the order */
  double package_total;
  double console_total;
  double gamepak_total;
  double game_total;

  /* total cost of the order */
  double total_cost;

  /* read in the values of each item needed */
  printf("How many consoles would you like to order: ");
  scanf("%d",&console_demand);

  printf("How many games would you like to order: ");
  scanf("%d",&game_demand);

  printf("Of the above orders, how many should be packages: ");
  scanf("%d",&package_demand);

  printf("\n");


  /* check if order can be fulfilled from current stock */
  if (console_demand > console_stock || game_demand > game_stock) {
    printf("Your order cannot be fulfilled because of insufficient stock.\n");
    exit(0); /* order error */
  }
  
  /* check  if enough games and consoles were ordered to fulill
     the package request */
  if (package_demand * CONSOLES_PER_PACKAGE > console_demand ||
	     package_demand * GAMES_PER_PACKAGE > game_demand) {
    printf("Your order cannot be fulfilled, as too many packages were requested.\n");
    exit(0); /* order error */
  } 

  /* main code: */
  printf("Your order was shipped:\n\n");

  /* update the current stock */
  console_stock = console_stock - console_demand;
  game_stock = game_stock - game_demand;

  /* calculate the number of individual items of each type being sent: */

  /* consoles are those not sent in packages */
  console_demand = console_demand - (package_demand * CONSOLES_PER_PACKAGE);

  /* fist -- games not being sent in packages */
  game_demand    = game_demand - (package_demand * GAMES_PER_PACKAGE);

  /* now these are put into gamepaks and individual games */
  gamepak_demand = game_demand / GAMES_PER_GAMEPAK;
  game_demand = game_demand % GAMES_PER_GAMEPAK;


  /* given the individual quantities of each item, calculate costs */
  package_total = package_demand * PACKAGE_COST;
  console_total = console_demand * CONSOLE_COST;
  gamepak_total = gamepak_demand * GAMEPAK_COST;
  game_total    = game_demand * GAME_COST;

  total_cost = package_total + console_total + gamepak_total + game_total;


  /* display the individual item demands and costs */
  printf("%d packages ...............\tcost  $%.2f\n", package_demand, package_total);
  
  printf("%d individual consoles ....\tcost  $%.2f\n", console_demand, console_total);
  
  printf("%d game paks ..............\tcost  $%.2f\n", gamepak_demand, gamepak_total);
  
  printf("%d individual games .......\tcost  $%.2f\n", game_demand, game_total);
  
  printf("                           \ttotal $%.2f\n",total_cost);


  /* display the remaining stock */
  printf("\nCurrent Stock\n");
  printf("Console Stock: \t%d\n",console_stock);
  printf("Game Stock:    \t%d\n",game_stock);


  /* pause display before program ends */
  printf("press enter to continue...\n");
  scanf("%c%c",&dummychar,&dummychar);
  return 0;
}
